Welcome to Subscribe On Youtube

Question

Formatted question description: https://leetcode.ca/all/310.html

Level

Medium

Description

For an undirected graph with tree characteristics, we can choose any node as the root. The result graph is then a rooted tree. Among all possible rooted trees, those with minimum height are called minimum height trees (MHTs). Given such a graph, write a function to find all the MHTs and return a list of their root labels.

Format

The graph contains n nodes which are labeled from 0 to n - 1. You will be given the number n and a list of undirected edges (each edge is a pair of labels).

You can assume that no duplicate edges will appear in edges. Since all edges are undirected, [0, 1] is the same as [1, 0] and thus will not appear together in edges.

Example 1:

Input: n = 4, edges = [[1, 0], [1, 2], [1, 3]]

        0
        |
        1
       / \
      2   3 

Output: [1]

Example 2:

Input: n = 6, edges = [[0, 3], [1, 3], [2, 3], [4, 3], [5, 4]]

     0  1  2
      \ | /
        3
        |
        4
        |
        5 

Output: [3, 4]

Note:

  • According to the definition of tree on Wikipedia: “a tree is an undirected graph in which any two vertices are connected by exactly one path. In other words, any connected graph without simple cycles is a tree.”
  • The height of a rooted tree is the number of edges on the longest downward path between the root and a leaf.

Algorithm

Any connected graph without simple cycles is a tree.

  1. Start storing all nodes (leaf nodes) with only one connected edge into a queue
  2. Then we traverse each leaf node, find the node connected to it through the graph, and delete the leaf node from the set of connected nodes
  3. If the node becomes a leaf node after deletion, add it to the queue and delete it in the next round
  4. Stop when the number of nodes is less than or equal to 2. At this time, the remaining one or two nodes are the root nodes of the minimum height tree we require

Code

  • import java.util.*;
    
    public class Minimum_Height_Trees {
    
        public class Solution {
    
            // @note: bfs to find min steps
            public List<Integer> findMinHeightTrees(int n, int[][] edges) {
    
                if (n == 1) {
                    return Collections.singletonList(0);
                }
    
                List<Set<Integer>> graph = new ArrayList<>(n);
    
                // build graph
                for (int i = 0; i < n; ++i) {
                    graph.add(new HashSet<>());
                }
                for (int[] edge : edges) {
                    graph.get(edge[0]).add(edge[1]);
                    graph.get(edge[1]).add(edge[0]);
                }
    
                // en-queue for leaf node
                List<Integer> leaves = new ArrayList<>();
                for (int i = 0; i < n; ++i) {
                    if (graph.get(i).size() == 1) {
                        leaves.add(i);
                    }
                }
    
                // batch removing leaf nodes
                while (n > 2) { // if n>=3 then can be further reduced
                    List<Integer> newLeaves = new ArrayList<>();
                    for (int oldLeaf: leaves) {
                        // leaves.remove(oldLeaf); // @note: arraylist remove by object
                        int newLeaf = graph.get(oldLeaf).iterator().next(); // should be only one in hashset, because it's a leaf node
                        graph.get(newLeaf).remove(oldLeaf); // @note: hashset remove by object
                        if (graph.get(newLeaf).size() == 1) {
                            newLeaves.add(newLeaf);
                        }
                    }
    
                    n -= leaves.size();
                    leaves = newLeaves;
                }
    
                return leaves;
            }
        }
    }
    
    ############
    
    class Solution {
        public List<Integer> findMinHeightTrees(int n, int[][] edges) {
            if (n == 1) {
                return Collections.singletonList(0);
            }
            List<Integer>[] g = new List[n];
            Arrays.setAll(g, k -> new ArrayList<>());
            int[] degree = new int[n];
            for (int[] e : edges) {
                int a = e[0], b = e[1];
                g[a].add(b);
                g[b].add(a);
                ++degree[a];
                ++degree[b];
            }
            Queue<Integer> q = new LinkedList<>();
            for (int i = 0; i < n; ++i) {
                if (degree[i] == 1) {
                    q.offer(i);
                }
            }
            List<Integer> ans = new ArrayList<>();
            while (!q.isEmpty()) {
                ans.clear();
                for (int i = q.size(); i > 0; --i) {
                    int a = q.poll();
                    ans.add(a);
                    for (int b : g[a]) {
                        if (--degree[b] == 1) {
                            q.offer(b);
                        }
                    }
                }
            }
            return ans;
        }
    }
    
  • // OJ: https://leetcode.com/problems/minimum-height-trees
    // Time: O(V + E)
    // Space: O(V + E)
    class Solution {
    public:
        vector<int> findMinHeightTrees(int n, vector<vector<int>>& E) {
            if (n == 1) return { 0 };
            vector<int> degree(n), ans;
            vector<vector<int>> G(n);
            for (auto &e : E) {
                int u = e[0], v = e[1];
                degree[u]++;
                degree[v]++;
                G[u].push_back(v);
                G[v].push_back(u);
            }
            queue<int> q;
            for (int i = 0; i < n; ++i) {
                if (degree[i] == 1) q.push(i);
            }
            while (n > 2) {
                int cnt = q.size();
                n -= cnt;
                while (cnt--) {
                    int u = q.front();
                    q.pop();
                    for (int v : G[u]) {
                        if (--degree[v] == 1) q.push(v);
                    }
                }
            }
            while (q.size()) {
                ans.push_back(q.front());
                q.pop();
            }
            return ans;
        }
    };
    
  • from typing import List, Set
    from collections import defaultdict
    
    
    class Solution:
        def findMinHeightTrees(self, n: int, edges: List[List[int]]) -> List[int]:
            if n == 1:
                return [0]
    
            graph = defaultdict(set)
            for a, b in edges:
                graph[a].add(b)
                graph[b].add(a)
    
            # just check neighbours[] size, not indgree[] for each node
            leaves = [i for i in range(n) if len(graph[i]) == 1]
    
            while n > 2:
                n -= len(leaves)
                new_leaves = []
                for leaf in leaves:
                    neighbor = graph[leaf].pop() # should be only one in hashset, because it's a leaf node
                    graph[neighbor].remove(leaf)
                    if len(graph[neighbor]) == 1:
                        new_leaves.append(neighbor)
                leaves = new_leaves
    
            return leaves
    
    ###############
    
    class Solution:
        def findMinHeightTrees(self, n: int, edges: List[List[int]]) -> List[int]:
            if n == 1:
                return [0]
            g = defaultdict(list)
            degree = [0] * n
            for a, b in edges:
                g[a].append(b)
                g[b].append(a)
                degree[a] += 1 # not needed, just len(g[a]) is good enough, will update it in next round updating
                degree[b] += 1
            q = deque()
            for i in range(n):
                if degree[i] == 1:
                    q.append(i)
            ans = []
            while q:
                n = len(q)
                ans.clear()
                for _ in range(n):
                    a = q.popleft()
                    ans.append(a)
                    for b in g[a]:
                        degree[b] -= 1
                        if degree[b] == 1: # final round only 2 left (a,b), then degree[b] here will be 0, and no more node enqueue
                            q.append(b)
            return ans
    
    ############
    
    from collections import deque
    
    
    class Solution(object):
      def findMinHeightTrees(self, n, edges):
        """
        :type n: int
        :type edges: List[List[int]]
        :rtype: List[int]
        """
        if len(edges) == 0:
          if n > 0:
            return [0]
          return []
    
        def bfs(graph, start):
          queue = deque([(start, None)])
          level = 0
          maxLevel = -1
          farthest = None
          while queue:
            level += 1
            for i in range(0, len(queue)):
              label, parent = queue.popleft()
              for child in graph.get(label, []):
                if child != parent:
                  queue.append((child, label))
                  if level > maxLevel:
                    maxLevel = level
                    farthest = child
          return farthest
    
        def dfs(graph, start, end, visited, path, res):
          if start == end:
            res.append(path + [])
            return True
          visited[start] = 1
          for child in graph.get(start, []):
            if visited[child] == 0:
              path.append(child)
              if dfs(graph, child, end, visited, path, res):
                return True
              path.pop()
    
        graph = {}
        for edge in edges:
          graph[edge[0]] = graph.get(edge[0], []) + [edge[1]]
          graph[edge[1]] = graph.get(edge[1], []) + [edge[0]]
    
        start = bfs(graph, edges[0][0])
        end = bfs(graph, start)
        res, visited = [], [0 for i in range(0, n)]
        dfs(graph, start, end, visited, [start], res)
        if not res:
          return []
        path = res[0]
        if len(path) % 2 == 0:
          return [path[len(path) / 2 - 1], path[len(path) / 2]]
        else:
          return [path[len(path) / 2]]
    
    
  • func findMinHeightTrees(n int, edges [][]int) []int {
    	if n == 1 {
    		return []int{0}
    	}
    	g := make([][]int, n)
    	degree := make([]int, n)
    	for _, e := range edges {
    		a, b := e[0], e[1]
    		g[a] = append(g[a], b)
    		g[b] = append(g[b], a)
    		degree[a]++
    		degree[b]++
    	}
    	var q []int
    	for i := 0; i < n; i++ {
    		if degree[i] == 1 {
    			q = append(q, i)
    		}
    	}
    	var ans []int
    	for len(q) > 0 {
    		ans = []int{}
    		for i := len(q); i > 0; i-- {
    			a := q[0]
    			q = q[1:]
    			ans = append(ans, a)
    			for _, b := range g[a] {
    				degree[b]--
    				if degree[b] == 1 {
    					q = append(q, b)
    				}
    			}
    		}
    	}
    	return ans
    }
    

All Problems

All Solutions